/*DIPintro.c (A. Christidis)*/

#include "LoadImg.h"
#include "DIPhisto.h"
#include "ShowAux.h"
#include "DIPintro.h"
#include "DIPops.h"
#include "FFTops.h"//muss nach ShowAux.h stehen 

#define IMG_PATH  "..\\..\\_data\\"
#define CON_CLS   "cls"
#define CR         13
#define ESC        27
#define MEDX        3
#define MEDY        3

#define TINYWIN    32

#define GREYLEVEL(x) x 
#ifdef  MORE_INTRO
#endif//MORE_INTRO

DIPimg        img, aoi;
int           aoiX0=0, aoiY0=0;
GLdouble      zoom=1.;
char          imgPath[80]=IMG_PATH;
int           winWid=TINYWIN, winHig=TINYWIN, mainWin=1, auxWin[WINADMIN];
int           histo=0, opti=0, imgCount=0;
char     gallery[][80]={ "EinsteinLowContrast.tif", "dot.bmp", "L+H1936.png", "3D08.jpg", 
                         "Mandrill256.rgb", "rectTlt.png","rectSft.png", "rectMid.png", 
                         "LenaSoederberg1997.jpg", "marbles.sgi", "telePrintPic1921.jpg", 
                         "quickBrownFoxBW.bmp", "quickBrownFoxWB.bmp", "Demo512x256.jpg",0};
                         //0: Absicherung, falls dahinter weitere char-Variablen stehen

/*Merke: extern darf nicht initialisiert werden! (Deklaration vs. Definition)*/
extern unsigned char  thresh, reverse, minMax, rTh[], gTh[], bTh[];
                int   conv=0;
                int   four=0, choise=LIN;
                int   numeric=0, numX=0, numY=0, numRGB=R, pseudoMode=0;

/***************************************************************************/
  void DrawIn2D (int width, int height)
/***************************************************************************/
/*2D-Zeichnen:*/
{ glViewport(0, 0, width, height);  //Aktuelle 2D-Zeichenflaeche
  glMatrixMode (GL_PROJECTION); 
  glLoadIdentity (); 
  glOrtho (0., (double)width, 0., (double)height, -1., 1.);
  glMatrixMode (GL_MODELVIEW); 
  glLoadIdentity(); 
  glTranslatef(0.375, 0.375, 0); //Displacement for exact pixelization
  return;
}

/***************************************************************************/
  void Display (void)
/***************************************************************************/
/*Callback-Funktion zur Fenster-Auffrischung*/
/*aoi erlaubt Unterscheidung zwischen Fenster- und Bildgroesse. 
  Beachte: Fenster-Reshape aendert Pixel-Zoom - nicht Pixel-Anzahl!*/
{ glDrawPixels(aoi.Width, aoi.Height, aoi.Format, GL_UNSIGNED_BYTE, aoi.Data);
  if (numeric) { system (CON_CLS);  
                 numberPic (&aoi, numX, numY, numRGB, pseudoMode); }
  glFinish(); 
  return;
}

/***************************************************************************/
  void copyDIPimg (DIPimg *srcImg, DIPimg *dstImg)
/***************************************************************************/
/*Kopieren des Inhalts der Bild-Struktur <srcImg> in die Struktur <dstImg>:*/
{ 
#ifdef  MORE_INTRO
#endif//MORE_INTRO

  return;
}

/***************************************************************************/
  void flyPic (void)
/***************************************************************************/
/*Pixelweise gesetztes Fliegen-Bild:*/
{ int jx=0, jy=0;

  strcpy (img.Name, "Fly"); 
  img.Width=TINYWIN;  img.Height=TINYWIN; 
  img.Format=GL_RGBA; img.Cmpnts=4;

/*Gleichbehandlung mit Bildern, zur spaeteren Freigabe free(img.Data).
  Sonst moeglich: img.Data=fly;*/
  img.Data = (unsigned int *) malloc (
              img.Height *img.Width * sizeof (unsigned int));
  if (!img.Data) { fprintf(stderr, "Out of memory!\n");  _getch();  return; }
  for(jy=0; jy<img.Height; jy++) 
  { for(jx=0; jx<img.Width; jx++) 
    { img.Data[jy*img.Width+jx] = fly[jy*img.Width+jx];
    }
  }
  return;
}

/***************************************************************************/
  void Greywedge (int width, int height)
/***************************************************************************/
/*Berechneter Graukeil:*/
{ int jx=0, jy=0;
  strcpy (img.Name, "Greywedge"); 
  img.Width=width;    img.Height=height; 
  img.Format=GL_RGBA; img.Cmpnts=4;

  img.Data = (unsigned int *) 
             malloc (height * width * sizeof (unsigned int));
  if (!img.Data) { fprintf(stderr, "Out of memory!\n");  _getch();  return; }

  for(jy=0; jy<height; jy++) 
  { for(jx=0; jx<width; jx++) 
    { img.Data[jy*width+jx] = GREYLEVEL  ((255*jx)/(width-1));
    }
  }
  return;
}

/***************************************************************************/
  int SaveAoI (int aoiX0, int aoiY0, int aoiWid, int aoiHig, char *filPath)
/***************************************************************************/
/*Speicherung eines Ausschnitts des aktuellen Fensters im RGBA-Format 
  nach SGI (Teil-Screenshot)*/
{ FILE          *imgFil;
           int  Cmpnts=4, jx=0, jy=0, jz=0;
  unsigned int  *Data=NULL; 

#ifdef  MORE_INTRO
#endif//MORE_INTRO

  /*Speicherung:*/
  Data = (unsigned int *) malloc (aoiHig*aoiWid*sizeof(unsigned int));
  if (!Data) { fprintf(stderr, "Out of memory!\n");  _getch();  return (0); }

  glReadPixels(aoiX0, aoiY0, aoiWid, aoiHig, GL_RGBA, GL_UNSIGNED_BYTE, Data);

  imgFil = fopen(filPath,"w+b");
  if(!imgFil) { fprintf(stderr,"sgiimage: can't open output file\n"); 
               _getch();  exit(0); }
  putshort(imgFil,474);         /* MAGIC               */
  putbyte(imgFil,0);            /* STORAGE is VERBATIM */

  putbyte(imgFil,1);            /* BPC is 1 - bytes per pixel component (RGB): 1 or 2          */
  putshort(imgFil,3);           /* DIMENSION is 3: multiple scanlines & channels  */
  putshort(imgFil,aoiWid);      /* XSIZE  - width              */
  putshort(imgFil,aoiHig);      /* YSIZE  - height              */
  putshort(imgFil,Cmpnts);      /* ZSIZE  - number of channels in the image: b/w: 1; RGB: 3; RGBA: 4 */
  
  putlong(imgFil,0);            /* PIXMIN is 0         */
  putlong(imgFil,255);          /* PIXMAX is 255       */
  for(jx=0; jx<4; jx++)         /* DUMMY 4 bytes       */
	putbyte(imgFil, 0);
  fwrite(filPath,80,1,imgFil);  /* IMAGENAME           */
  putlong(imgFil,0);            /* COLORMAP is 0       */
  for(jx=0; jx<404; jx++)       /* DUMMY 404 bytes     */
    putbyte(imgFil,0);

  for(jz=0; jz<Cmpnts; jz++) 
  { for(jy=0; jy<aoiHig; jy++) 
    { for(jx=0; jx<aoiWid; jx++) 
      {
#ifdef  MORE_INTRO
#endif//MORE_INTRO
      }
    }
  }
  fclose(imgFil);
  free(Data);
  return (1);
}

/***************************************************************************/
  void menue (void) 
/***************************************************************************/
{ system (CON_CLS);
  printf (" DIPintro: Digital Image Processing Introductory techniques\n");
  printf ("\n Current pic:%4d x%4d (%s)", img.Width, img.Height, img.Name);
  printf ("\n Current win:%4d x%4d", winWid, winHig);
  printf ("\n\n Keep picture window active and press\n");
  printf ("\n <ESC> to quit ");
  printf ("\n <CR>     go through gallery");
  printf ("\n 1/2      show Fly / Greywedge");
  printf ("\n 3/4/5/6  load Baboon.bw / Lena.rgb / Fendi.jpg / Bottles512.tga");
  printf ("\n 7        load example.rgb");
  printf ("\n c        convolve original picture with filter.flt"); 
  if (conv) { printf ("\n   c      convolution with filter.flt"); 
              printf ("\n  <SP>    convolution with filter.flt & its transpose"); 
              printf ("\n   C      convolution only with filter.flt transpose"); }

  printf ("\n f        Fourier tools"); 
  if (four) { printf ("\n   c      convolution with filter.flt"); 
              printf ("\n   f      Fourier spectrum "); 
              printf ("\n   i      inverse filtering with filter.flt");
            }
  printf ("\n g        convert original into a geylevel picture ");

  printf ("\n h        toggle histogram current picture ");
         if (histo) printf ("(ON)"); else printf ("(OFF)"); 
  printf ("\n m        median filter original picture (%dx%d mask)", MEDY, MEDX);
  printf ("\n n        toggle numeric picture representation ");
  printf ("\n o        toggle optimum ");  if (opti)  printf ("(ON) "); 
  printf ("/ original ");  if (!opti) printf ("(ON) "); printf ("contrast "); 
  printf ("\n r        return current picture to original size");
  printf ("\n s        save window content as 'example.rgb'");
  printf ("\n t        toggle threshold application "); 
         if (!thresh) printf ("(OFF)"); else { printf ("(ON)");
  printf ("\n   <CR>   toggle affecting both "); if (minMax) printf ("(ON) "); 
  printf ("/ upper "); if (!minMax) printf ("(ON) "); printf ("component limit/s"); 
  printf ("\n   r / R  decrease/increase Red:   [%3d, %3d] curr.", rTh[0], rTh[1]);
  printf ("\n   g / G  decrease/increase Green: [%3d, %3d] curr.", gTh[0], gTh[1]);
  printf ("\n   b / B  decrease/increase Blue:  [%3d, %3d] curr.", bTh[0], bTh[1]);
  printf ("\n   w / W  decrease/increase all components (white)");
  printf ("\n   v      reverse marking ");
         if (reverse) printf ("(ON)"); else printf ("(OFF)"); }
  printf ("\n <other>  cancel processing, restore original\n");

  return;
}

/***************************************************************************/
  void Keyboard (unsigned char key, int x, int y)
/***************************************************************************/
/*Menue und Eingabe-Behandlung:*/
{ int jj=0;

  if (numeric && key != 'n' && key != ' ' 
              && key != 'r' && key != 'g' && key != 'b'
              && key != 'w' && key != 'a' && key != 's' && key != 'd') 
      { numeric = 0; }
  if (thresh && key != 't' && key != 'v' && key != CR  &&
                key != 'r' && key != 'g' && key != 'b' && key != 'w' && 
                key != 'R' && key != 'G' && key != 'B' && key != 'W') 
      { thresh = 0;  reverse = 0; }
  if (conv && key != 'c' && key != 'C' && key != ' ') conv = 0;
  if (four && key != 'c' && key != 'C' && key != 'f' && key != 'i'
) four = 0;

  /*Histogramm, falls vorhanden, ab jetzt obsolet:*/
  if (key != 'h') 
  { histo = 0; if (key != 'o') opti = 0; 
    for (jj=0; jj<WINADMIN; jj++) 
    { if (auxWin[jj])
      { glutDestroyWindow(auxWin[jj]);  auxWin[jj]=0; }
    }
  } 
  /*Jeder Tastendruck gilt dem Hauptfenster:*/
  glutSetWindow(mainWin);
  switch (key)
  { case ESC: exit(0);

    case ' ': if (numeric) { pseudoMode = 1 - pseudoMode; } else 
              { memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4);
                if (conv) {convol (&img, &aoi, DIFXY);  conv = 0; }  
              } break;

    case CR:  if (thresh) { minMax = 1 - minMax; } else
              { if (!(*gallery[imgCount])) imgCount = 0; //1. gelesenes Zeichen=0
                strcpy (img.Name, gallery[imgCount]); 
                glutSetWindowTitle(img.Name);
                strcpy (imgPath, IMG_PATH); 
                strcat (imgPath, img.Name);
                free(img.Data);  free(aoi.Data);
                init (imgPath);  copyDIPimg (&img, &aoi);
                Reshape (img.Width, img.Height);  
                imgCount++;
              } break;

    case '1': free(img.Data);  free(aoi.Data);
              flyPic();
              glutSetWindowTitle(img.Name);
              copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height);
              break;

    case '2': free(img.Data);  free(aoi.Data);
              Greywedge (16*TINYWIN, 8*TINYWIN);
              glutSetWindowTitle(img.Name);
              copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height); 
              break;

    case '3': free(img.Data);  free(aoi.Data);
              strcpy (img.Name, "baboon.bw"); 
              glutSetWindowTitle(img.Name);
              strcpy (imgPath, IMG_PATH); 
              strcat (imgPath, img.Name);
              init (imgPath);  copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height);
              break;

    case '4': free(img.Data);  free(aoi.Data);
              strcpy (img.Name, "Lena.rgb"); 
              glutSetWindowTitle(img.Name);
              strcpy (imgPath, IMG_PATH); 
              strcat (imgPath, img.Name);
              init (imgPath);  copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height); 
              break;

    case '5': free(img.Data);  free(aoi.Data);
              strcpy (img.Name, "Fendi.jpg"); 
              glutSetWindowTitle(img.Name);
              strcpy (imgPath, IMG_PATH); 
              strcat (imgPath, img.Name);
              init (imgPath);  copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height);
              break;

    case '6': free(img.Data);  free(aoi.Data);
              strcpy (img.Name, "Bottles512.tga"); 
              glutSetWindowTitle(img.Name);
              strcpy (imgPath, IMG_PATH); 
              strcat (imgPath, img.Name);
              init (imgPath);  copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height);  
              break;

    case '7': free(img.Data); free(aoi.Data);
              strcpy (img.Name, "example.rgb"); 
              glutSetWindowTitle(img.Name);
              strcpy (imgPath, IMG_PATH); 
              strcat (imgPath, img.Name);
              init (imgPath);  copyDIPimg (&img, &aoi);
              Reshape (img.Width, img.Height);    
              break;

    case 'a': if (numeric) { if (numX > 0) numX--; }
              break;

    case 'b': if (thresh) { if (minMax && bTh[0] > 0) bTh[0]--;
                            if (bTh[1] > bTh[0]) bTh[1]--; 
                            threshPic (&img, &aoi);
                          }
              else if (numeric) numRGB = B; 
              break;

    case 'B': if (thresh) { if (bTh[1] < 255) bTh[1]++; 
                            if (minMax && bTh[0] < bTh[1]) bTh[0]++;
                            threshPic (&img, &aoi);
                          }
              break;

    case 'c': memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4);
              if (conv) { convol (&img, &aoi, INTEG);  conv = 0; }
              else if (four) { Ffilt (&img, &aoi, CONV);  four = 0; }
              else { conv = 1; }
              break;

    case 'C': memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4);
              if (conv) { convol (&img, &aoi, DIFFY);  conv = 0; }  
              break;

    case 'd': if (numeric) { if (numX < aoi.Width-NUMX) numX++; }
              break;

    case 'f': memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4);
              if (four) { Fspec (&img, &aoi, (choise++)%(OWN+1));  /*four = 0; */ }
              else { four = 1;  choise = LIN;}
              break;

    case 'g': if (thresh) { if (minMax && gTh[0] > 0) gTh[0]--; 
                            if (gTh[1] > gTh[0]) gTh[1]--;
                            threshPic (&img, &aoi);
                          } 
              else if (numeric) numRGB = G; 
              else cv2grey (&img, &aoi); 
              break;

    case 'G': if (thresh) { if (gTh[1] < 255) gTh[1]++;
                            if (minMax && gTh[0] < gTh[1]) gTh[0]++; 
                            threshPic (&img, &aoi);
                          } 
              break;

    case 'h': histo = 1 - histo; 
              if (histo)
              { aoi.Width=img.Width;  aoi.Height=img.Height;  aoiX0=0;  aoiY0=0;
                aoi.Cmpnts=img.Cmpnts;
                Hist ();
              } else /*Histogramm ausschalten:*/
              { for (jj=0; jj<WINADMIN; jj++) 
                { glutDestroyWindow(auxWin[jj]); auxWin[jj]=0; } 
                  glutSetWindow(mainWin);
              }
              break;

    case 'i': if (four) { Ffilt (&img, &aoi, INVR);  four = 0; }
              break;

    case 'm': median (&img, &aoi, MEDY, MEDX);
              break;

    case 'n': numeric = 1 - numeric;
              if (!numeric || numX > aoi.Width-NUMX || numY > aoi.Height-NUMY) 
              { numX = MAX(0, (aoi.Width-NUMX)/2); numY = MAX(0, (aoi.Height-NUMY)/2); numRGB = R; }
              break;

    case 'o': opti = 1 - opti;
              if (opti) optiCont (&img, &aoi);
              else      memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4);
              break;

    case 'r': if (thresh) { if (minMax && rTh[0] > 0) rTh[0]--;
                            if (rTh[1] > rTh[0]) rTh[1]--; 
                            threshPic (&img, &aoi); 
                          } 
              else if (numeric) numRGB = R; 
              else glutReshapeWindow (img.Width, img.Height); 
              break;

    case 'R': if (thresh) { if (rTh[1] < 255) rTh[1]++; 
                            if (minMax && rTh[0] < rTh[1]) rTh[0]++;
                            threshPic (&img, &aoi);
  }
              break;

    case 's': if (numeric) { if (numY < aoi.Height-NUMY) numY++; } 
              else         SaveAoI (aoiX0, aoiY0, aoi.Width*zoom, aoi.Height*zoom, 
                                    "..\\..\\_data\\example.rgb");
              break;

    case 't': thresh = 1 - thresh;
              if (thresh) threshPic (&img, &aoi);
              else { reverse = 0;
              rTh[0]=gTh[0]=bTh[0]=128;
              rTh[1]=gTh[1]=bTh[1]=128;
              memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4); }
              break;

    case 'v': if (thresh) { reverse = 1 - reverse;
              threshPic (&img, &aoi); }
              break;

    case 'w': if (thresh) { if (minMax) { if (rTh[0] > 0) rTh[0]--; 
                                          if (gTh[0] > 0) gTh[0]--;
                                          if (bTh[0] > 0) bTh[0]--; }
                            if (rTh[1] > rTh[0]) rTh[1]--; 
                            if (gTh[1] > gTh[0]) gTh[1]--;
                            if (bTh[1] > bTh[0]) bTh[1]--;
                            threshPic (&img, &aoi);
                          }
              else if (numeric) { if (numY > 0) numY--; }
              break;

    case 'W': if (thresh) { if (rTh[1] < 255) rTh[1]++; 
                            if (gTh[1] < 255) gTh[1]++;
                            if (bTh[1] < 255) bTh[1]++;
                            if (minMax) { if (rTh[0] < rTh[1]) rTh[0]++; 
                                          if (gTh[0] < gTh[1]) gTh[0]++;
                                          if (bTh[0] < bTh[1]) bTh[0]++; }
                            threshPic (&img, &aoi);
                          } 
              break;
    default:  /*Tabula rasa*/
              histo=0;  opti=0; 
              conv = 0; thresh = 0;  reverse = 0;  minMax=1; 
              rTh[0]=gTh[0]=bTh[0]=128;
              rTh[1]=gTh[1]=bTh[1]=128;
              memcpy (aoi.Data, img.Data, aoi.Height * aoi.Width * 4);
  }
#ifdef  MORE_INTRO
#endif//MORE_INTRO
  if (!numeric) menue(); //kein Menue bei Zahlendarstellung

  return;
}

/***************************************************************************/
  void Reshape (int w, int h)
/***************************************************************************/
/*Pixelgroesse (zoom x zoom) und Fenstergroesse aktualisieren:*/
{
#ifdef  MORE_DIP
#endif//MORE_DIP
  glPixelZoom (zoom, zoom);

  /*Fenster- und Speichergroesse global aktualisieren:*/
  winWid = w;  winHig = h;

  /*Bei direkten Aufrufen: GLUT neue Fenstergroesse mitteilen:*/
  glutReshapeWindow (w, h); 

  /*Fenstersystem die aktuelle Zeichenflaeche mitteilen:*/
  DrawIn2D (zoom*img.Width, zoom*img.Height);

  /*Menue aktualisieren:*/
  menue();
  glFinish(); 
  return;
}

/***************************************************************************/
  int main(int argc, char *argv[])
{ if (argc == 2)
  { init (argv[1]);
    strcpy (img.Name, argv[1]); 
    copyDIPimg (&img, &aoi);
  } else //eines der beiden folgenden auskommentieren:
  //{ Greywedge (16*TINYWIN, 8*TINYWIN);
  { flyPic(); 
    copyDIPimg (&img, &aoi);
    winWid = img.Width;  winHig = img.Height;
    aoi.Width = img.Width;  aoi.Height = img.Height;
  }
  glutInitWindowSize(winWid, winHig);       /*Fenstergroesse*/
  glutInit(&argc, argv);                    /*Intialisierg, Speicherreservierg*/
  glutInitWindowPosition(HIST_DIM+20, 0);   /*Platz fuer Hilfsfenster*/
  mainWin = glutCreateWindow(img.Name);     /*Fenster-Einrichtung*/
  DrawIn2D (winWid, winHig);

  glClearColor(.0, .0, .0, .0);             /*Loeschfarbe, muss nach glutInit stehen*/
  glutDisplayFunc (Display);                /*Anmeldung der Callback-Funktion*/
  glutReshapeFunc (Reshape);                /*Callback-Funktion bei Aenderung der Festergroesse*/
  glutKeyboardFunc(Keyboard);               /*Callback-Funktion fuer Tasten*/
  glutReshapeWindow(img.Width, img.Height); /*Bei ungewoehnlich kleinen Fenstern: Erinnerung*/

  glutMainLoop();                           /* we never return...Start d. Ereignis-Verarbeitung durch GLUT*/ 
  return 0;                                 /* ANSI C requires main to return int. */
}
