/*DIPops.c (A. Christidis)*/

#include "LoadImg.h"
#include "DIPops.h"
#include "ShowAux.h"

/*Merke: extern darf nicht initialisiert werden! (Deklaration vs. Definition)*/
extern DIPimg img, aoi;

unsigned char   thresh=0, reverse=0, minMax=1, 
                rTh[]={128,128}, gTh[]={128,128}, bTh[]={128,128};
         int    maskW=0, maskH=0;
         float *mask=NULL;
         char   pseudo[]={'.', '-', '=', '+', ':', (char)246, '*', '8', '#', 
                              (char)176, (char)177, (char)178, (char)219};

/***************************************************************************/
  void numberPic (DIPimg *srcImg, int x, int y, int cmpnt, int pseudoMode)
/***************************************************************************/
/*Ausgabe von (NUMX x NUMY) R-,G- oder B-Werte eines (kopfueber gespeicherten) 
  Bildes im (geloeschten) Ausfuehrungsfenster. Fensterkoordinaten-Ursprung 
  ist oben links (y waechst hier nach unten, im Bildspeicher nach oben). */
{          int      jx=0, jy=0;
  unsigned char     pixel[]={0, 0, 0, 0};
  unsigned int     *ipixel =(unsigned int*)pixel;
  extern   int      mainWin;
  extern   GLdouble zoom;
           int      x1=x, x2=x1, y1=y, y2=y1;//(x1, y1) soll o.li. ins Fenster
           int      jj=0, val=0, pseu=0;

 /*Umrechnung von Fenster- in Speicherkoordinaten:*/
#ifdef  MORE_OPS
#endif//MORE_OPS

 /*Ausgabe der Pixelwerte (aufgerichtet!):*/
  for(jy=y1; jy>=y2; jy--) 
  { for(jx=x1; jx<=x2; jx++) 
    { *ipixel = srcImg->Data[jy*srcImg->Width+jx];
      if (!pseudoMode)
      { if (jx==x1) printf ("%3d", pixel[cmpnt]);  else printf ("%4d", pixel[cmpnt]); }
#ifdef  MORE_OPS
#endif//MORE_OPS
    } printf ("\n");
  } printf ("\n");
  printf ("[%d,%d]-[%d,%d]    ", y, x, 
          (MIN(y+NUMY, srcImg->Height)-1), (MIN(x+NUMX, srcImg->Width)-1));
  printf ("Move: 'a','d' & 'w','s';  Change: <SP>");  
  printf (" 'r'");  if (cmpnt == R) printf ("[ON]"); 
  printf (",'g'");  if (cmpnt == G) printf ("[ON]"); 
  printf (",'b'");  if (cmpnt == B) printf ("[ON]"); 

  /*Markierung im Bild (inkl. Zooming):*/
  glutSetWindow(mainWin);
  glColor3ub(255, 255, 0);
  glBegin (GL_LINE_LOOP);
    glVertex2i(zoom*x1,zoom*(y1+1)-1); glVertex2i(zoom*(x2+1)-1, zoom*(y1+1)-1); 
    glVertex2i(zoom*(x2+1)-1,zoom*y2); glVertex2i(zoom*x1, zoom*y2);
  glEnd();
  glFinish(); 
  return;
}

/***************************************************************************/
  void cv2grey (DIPimg *srcImg, DIPimg *dstImg)
/***************************************************************************/
/*Farbe-zu-Grauwert-Konvertierung (bei S/W-Bildern wirkungslos)
  Quellbild <srcImg> und Ergebnisbild <dstImg> koennen auf identischen 
  Speicher zugreifen. */
{ int  jx=0, jy=0;
#ifdef  MORE_OPS 
#endif//MORE_OPS

 /*Transformation der Pixel:*/
  for(jy=0; jy<dstImg->Height; jy++) 
  { for(jx=0; jx<dstImg->Width; jx++) 
    {
#ifdef  MORE_OPS
#endif//MORE_OPS
    }
  }
  return;
}

/***************************************************************************/
  void threshPic (DIPimg *srcImg, DIPimg *dstImg)
/***************************************************************************/
/*Kennzeichnung der Pixel eines Bildes, deren Farbwerte innerhalb bzw. 
  ausserhalb eines gewaehlten Intervalls ([rTh[0], rTh[1]] - entsprechend mit 
  gTh[] und bTh[]) liegen; diese Pixel erhalten einen einheitlichen Farbton.*/
#ifdef  MY_DIP
/*Tips: In Fendi.jpg Frauenhaare mit R[0,255], G[0,255], B[1,255];
  Gruene Murmeln in marbles.sgi mit R[0,150], G[80,255], B[20,190]
  Fly mit RGB[1,254] */
#endif//MY_DIP
{          int  jx=0, jy=0;
  unsigned char pixel[]={0, 0, 0, 0},          mark[]={255, 0, 128, 255};
  unsigned int *ipixel =(unsigned int*)pixel, *imark=(unsigned int*)mark;

 /*Transformation der Helligkeitswerte:*/
  for(jy=0; jy<dstImg->Height; jy++) 
  { for(jx=0; jx<dstImg->Width; jx++) 
    { *ipixel = img.Data[jy*dstImg->Width+jx];
      if (reverse)
      { if ((pixel[R] < rTh[0] || pixel[R] > rTh[1]) ||
            (pixel[G] < gTh[0] || pixel[G] > gTh[1]) || 
            (pixel[B] < bTh[0] || pixel[B] > bTh[1])) *ipixel = *imark;
      } 
#ifdef  MORE_OPS
#endif//MORE_OPS
      dstImg->Data[jy*dstImg->Width+jx] = *ipixel;
    }
  }
  return;
}


/***************************************************************************/
  void median (DIPimg *srcImg, DIPimg *dstImg, int mskR, int mskC)
/***************************************************************************/
/*Medianfilterung innerhalb einer Umgebung (Maske) von <mskR> Reihen und 
  <mskC> Spalten.*/
{ unsigned int  *range=NULL;
           int  jx=0, jy=0;
#ifdef  MORE_OPS
#endif//MORE_OPS

  /*Ergebnis-Bild initialisieren:*/
  for(jx=0; jx<srcImg->Height*srcImg->Width; jx++) dstImg->Data[jx] = 0;

  /*Platzreservierung fuer Pixel im Masken-Bereich, Masken-Check mit 
    Zurueckweisung geradzahliger Zeilen- oder Spaltenanzahl:*/
  if (!(mskR & 1) || !(mskC & 1))
     { fprintf(stderr, "\n Wrong mask size!\n (Press any key to return)\n");  
      _getch();  return; }


  range = (unsigned int *) calloc (mskC*mskR, sizeof (unsigned int));
  if (!(range)) { fprintf(stderr, "Out of memory!\n");  _getch();  return; }

  /*Filterung durch Bewegung der Maske ueber das Bild:*/
  for(jy=mskR/2; jy<srcImg->Height-mskR/2; jy++) 
  { for(jx=mskC/2; jx<srcImg->Width-mskC/2; jx++) 
    { 
#ifdef  MORE_OPS
#endif//MORE_OPS

      /*Uebernahme des Medianwertes:*/
      dstImg->Data[jy*srcImg->Width+jx] = range[mskR*mskC/2];
    }

#ifdef  MORE_OPS
#endif//MORE_OPS
  }
  free (range);
  return;
}

/***************************************************************************/
  void loadMask (float **msk, int *mskR, int *mskC)
/***************************************************************************/
{          int  jx=0, jy=0;
  FILE         *flt;
  unsigned int  ipixel=0;
  unsigned char *pixel =(unsigned char *)&ipixel;

  /*Laden der Maske:*/
  if ((flt = fopen("..\\..\\_data\\filter.flt","r"))==NULL &&
       (flt = fopen("filter.flt","r"))==NULL) 
     { fprintf(stderr, "\n Error!\n");  _getch();  return; }

  /*Platzreservierung fuer Masken-Elemente, Masken-Check:*/
  fscanf(flt,"%d %d", mskR, mskC);
  *msk = (float *) malloc ((*mskC)*(*mskR)*sizeof (float));
  if (!(*msk)) { fprintf(stderr, "Out of memory!\n");  _getch();  return; }

  /*Masken-Elemente laden:*/
  for (jx=0; jx<(*mskC)*(*mskR); jx++)  fscanf(flt,"%f", (*msk+jx)); 

  fclose (flt);
  return;
}

/***************************************************************************/
  void normMask (float *msk, int mskR, int mskC)
/***************************************************************************/
{ /*Normierung einer Maske ab der Adresse <msk> mit <mskR> Reihen 
  und <mskC> Spalten auf Summe 1*/
  float sum=0.f;
  int  jx=0;

  /*Masken-Elemente auf Summe 1 normieren:*/
  for (jx=0; jx<mskC*mskR; jx++)  sum += *(msk+jx); if (sum < .0001) return;
  for (jx=0; jx<mskC*mskR; jx++)  *(msk+jx) /= sum; 

 return;
}

/***************************************************************************/
  void mirrMask (float *msk, int mskR, int mskC)
/***************************************************************************/
{ /*Spiegelung der Elemente einer Maske ab der Adresse <msk> 
  mit <mskR> Reihen und <mskC> Spalten*/
#ifdef  MORE_OPS
#endif//MORE_OPS

  /*Masken-Elemente an x- und y-Achse spiegeln:*/
#ifdef  MORE_OPS
#endif//MORE_OPS
 return;
}

/***************************************************************************/
  void BottomUp (unsigned int *src, unsigned int *dst, int w, int h)
/***************************************************************************/
/*Bild von Breite <w> und Hoehe <h> umdrehen 
  (OpenGL speichert Bilder kopfunter):
  Bilddaten von Quelle <src> und Ziel <dst> koennen identisch sein.*/
{
           int  jx=0, jy=0;
#ifdef  MORE_OPS
#endif//MORE_OPS

  for (jy=0; jy<=h/2; jy++)
  { for (jx=0; jx<w; jx++)
    {
#ifdef  MORE_OPS
#endif//MORE_OPS
    }
  }
}

/***************************************************************************/
  void convol (DIPimg *srcImg, DIPimg *dstImg, int purpose)
/***************************************************************************/
/*Faltung des Eingangsbildes mit der Matrix in einer vorgegebenen Datei:*/
{          int  jx=0, jy=0, jr=0, jc=0, jRGB=0;
  unsigned int  *dummySrc=NULL, *dummyDst=NULL;
#ifdef  MORE_OPS
#endif//MORE_OPS

  /*Aufrecht gespeicherte Arbeitskopien: 
   (Echtzeit-ungeeignet! Sie erleichtern nur den Umgang mit Indizes)*/
  dummySrc = (unsigned int *) 
              malloc(srcImg->Height * srcImg->Width * sizeof(unsigned int));
  if (!dummySrc) 
  { fprintf(stderr, "dummySrc Out of memory!\n");  _getch();  exit(1); }
  /*Ursprungsbild aufrecht gedreht:*/
  BottomUp (srcImg->Data, dummySrc, srcImg->Width, srcImg->Height);

  /*Platz fuer aufrechtes Ergebnisbild, mit Nullen initialisiert:*/
  dummyDst = (unsigned int *) 
              calloc(srcImg->Height * srcImg->Width, sizeof(unsigned int));
  if (!dummyDst) 
  { fprintf(stderr, "dummyDst Out of memory!\n");  _getch();  exit(1); }

  /*Laden, Normieren und Spiegeln der PSF, Masken-Check:*/
  loadMask (&mask, &maskH, &maskW);
  normMask (mask, maskH, maskW);
  mirrMask (mask, maskH, maskW);

  /*Fuehrung der Faltungsmaske ueber das Bild, von o.li. nach u. re.:*/
#ifdef  MORE_OPS
#endif//MORE_OPS

  /*Rueckfuehrung in die Kopfstellung:*/
  BottomUp (dummyDst, dstImg->Data, srcImg->Width, srcImg->Height);

  free (dummySrc);
  free (dummyDst);
  free (mask);
  return;
}
