/*ShowAux.c (A. Christidis) */

#include "ShowAux.h"

/*Globale Variablen:*/
extern DIPimg    img, aoi;

/* *********************************************************************** */
   int checkForm (char *imgNam, int *imgWid, int *imgHig)
/* *********************************************************************** */
{
#define NWORDS 5
  int   idum=0, swapFlag=0; 
  unsigned short sdum=0;
  union { int   iTest[NWORDS]; 
          unsigned short sTest[NWORDS*2]; 
          char  cTest[NWORDS*4]; } store;
  FILE *imgFil=NULL;

  /* Endian test */
  store.iTest[0] = 1; if (store.cTest[0] == 1) swapFlag = 1; 

  /* Read significant part of header */
  if (!(imgFil = fopen (imgNam, "rb"))) return (FAIL);
  fseek (imgFil, 0, SEEK_SET);
  idum = fread (store.cTest, sizeof (char), NWORDS*4, imgFil); 
  fclose (imgFil);
  if (idum != NWORDS*4) return (FAIL);

  /* SGI format? */
  sdum = store.sTest[0];  if (swapFlag) ConvertShort(&sdum, 2); 
  if (sdum == 474) 
  { if (swapFlag) ConvertShort(store.sTest, 6); 
    *imgWid = (unsigned short) store.sTest[3];
    *imgHig = (unsigned short) store.sTest[4];
    return (SGI);
  }

  /* TGA format? */
  if (store.cTest[1] == 0 && (store.cTest[2] == 2 || store.cTest[2] == 3))
  { *imgWid = (unsigned short) store.sTest[6];
    *imgHig = (unsigned short) store.sTest[7];
    return (TGA);
  }

  /* Leave it to OpenCV! */
  return (OCV);
#undef  NWORDS
}

/* *********************************************************************** */
   void ocvBottomUp (IplImage  *ocvimg)
/* *********************************************************************** */
/* Turn IplImage data bottom up (as needed for OpenGL treatment */
{ unsigned char *dummyImg=NULL;
  int            jhig=0, jwid=0, jcomp=0, ocvIdx=0, oglIdx=0;
  int            imgHig=ocvimg->height, imgWid=ocvimg->width, 
                 components=ocvimg->nChannels;

  dummyImg = (unsigned char *) malloc(imgHig * imgWid * components);
  if (!dummyImg) { fprintf(stderr, "Out of memory!\n");  _getch();  exit(1); }
  memcpy (dummyImg, ocvimg->imageData, imgHig * imgWid * components);

//#define DOITYOURSELF
  for (jhig=0; jhig<imgHig; jhig++)
  { for (jwid=0; jwid<imgWid; jwid++)
    { for (jcomp=0; jcomp<components; jcomp++)
      { ocvIdx = jhig * imgWid * components + jwid * components + jcomp; 
#ifdef  MORE_INTRO
#else //MORE_INTRO
        oglIdx = ocvIdx;
#endif//MORE_INTRO
       (ocvimg->imageData)[ocvIdx] = dummyImg[oglIdx];
      }
    }
  }
#ifdef  DOITYOURSELF
#else //DOITYOURSELF
  cvCvtColor(ocvimg, ocvimg, CV_BGR2RGB); 
#endif//DOITYOURSELF
  free (dummyImg);
  return;
}

/* *********************************************************************** */
   void init (char *imgFil)
/* *********************************************************************** */
/* Load image and convert it into GL_RGBA Format (4 bytes/pixel). */
{ unsigned int  ipixel;
  unsigned char *pixel=(unsigned char *)&ipixel;
           int  form=FAIL, jhig, jwid, jcomp, oglIdx;
       IplImage *OCVdum=NULL;
       DIPimg    DIPdum;

  form = checkForm (imgFil, &img.Width, &img.Height);

  /*First load in an dummy structure, then convert into a DIPimg, as the 
    standard image format to be processed (4 bytes per pixel, GL_RGBA).*/ 

  switch (form)
  { case SGI: /*read_texture() speichert Pixel immer in 4 Byte, unabhaengig
                vom <Cmpnts>-Wert; 1. Pixel ist u.li. (wie DIPintro):*/
              DIPdum.Data = read_texture(imgFil, 
                 &DIPdum.Width, &DIPdum.Height, &DIPdum.Cmpnts, &DIPdum.Format);
              /*Uebernahme / Setzen der Struktur-Elemente:*/
              img.Width  = DIPdum.Width; 
              img.Height = DIPdum.Height; 
              img.Cmpnts = 4;
              img.Format = GL_RGBA;
              img.Data = (unsigned int *) malloc (
                 img.Height * img.Width * sizeof (unsigned int));

              /*Pixelweise Bild mit 4 Byte/Pixel erzeugen:*/
              for (jhig=0; jhig<img.Height; jhig++)
              { for (jwid=0; jwid<img.Width; jwid++)
                { oglIdx = jhig * img.Width + jwid; 
                  ipixel = (DIPdum.Data)[oglIdx];
                  for (jcomp=0; jcomp<img.Cmpnts; jcomp++)
                    if (jcomp >= DIPdum.Cmpnts) pixel[jcomp] = 255;
                  (img.Data)[oglIdx] = ipixel;
                }
              }
              if (DIPdum.Data) free(DIPdum.Data);
              break;

    case TGA: /*loadTGA() verwendet exakt <Cmpnts> Byte pro Pixel => Umspeicherung auf 
              4 Byte noetig; 1. Pixel ist u.li. (wie DIPintro):*/
              DIPdum.Data = loadTGA (imgFil, 
                 &DIPdum.Width, &DIPdum.Height, &DIPdum.Cmpnts, &DIPdum.Format);
              /*Uebernahme / Setzen der Struktur-Elemente:*/
              img.Width  = DIPdum.Width; 
              img.Height = DIPdum.Height; 
              img.Cmpnts = 4;
              img.Format = GL_RGBA;
              img.Data = (unsigned int *) malloc (
                 img.Height * img.Width * sizeof (unsigned int));

              /*Pixelweise Bild mit 4 Byte/Pixel erzeugen:*/
              for (jhig=0; jhig<img.Height; jhig++)
              { for (jwid=0; jwid<img.Width; jwid++)
                { oglIdx = jhig * img.Width + jwid; 
                  for (jcomp=0; jcomp<img.Cmpnts; jcomp++)
                    if (jcomp < DIPdum.Cmpnts) 
                      //pixel[jcomp] = *(((unsigned char *)DIPdum.Data)+oglIdx++);
                      pixel[jcomp] = *(((unsigned char *)DIPdum.Data)+oglIdx*DIPdum.Cmpnts+jcomp);
                    else pixel[jcomp] = 255;
                  (img.Data)[oglIdx] = ipixel;
                }
              }
              if (DIPdum.Data) free(DIPdum.Data);
              break;

    case OCV: /*cvLoadImage() verwendet exakt <nChannels> Byte BGR pro Pixel => Umspeicherung auf 
              4 Byte RGBA noetig; 1. Pixel ist o.li. (deshalb ocvBottomUp()):*/
              OCVdum = cvLoadImage(imgFil, 1);
              assert(OCVdum);
              /*Uebernahme / Setzen der Struktur-Elemente:*/
              img.Width = OCVdum->width;
              img.Height = OCVdum->height;
              img.Cmpnts = 4;
              img.Format = GL_RGBA;
              img.Data = (unsigned int *) malloc (
                 img.Height * img.Width * sizeof (unsigned int));

              /*Bottom-Up in RGB:*/
              ocvBottomUp (OCVdum);
              //cvCvtColor(OCVdum, OCVdum, CV_BGR2RGB); //Verlegung in ocvBottomUp()
              /*Warnung vor unerklaerlichem Effekt:*/
              if ((OCVdum->width * OCVdum->height/4)*4 != OCVdum->width * OCVdum->height)
              { fprintf(stderr, "\n\n Sorry, it won't work!"); 
                fprintf(stderr, "\n (To continue, press any key in this window)\n"); 
               _getch(); }

              /*Pixelweise Bild mit 4 Byte/Pixel erzeugen:*/
              for (jhig=0; jhig<img.Height; jhig++)
              { for (jwid=0; jwid<img.Width; jwid++)
                { oglIdx = jhig * img.Width + jwid; 
                  for (jcomp=0; jcomp<img.Cmpnts; jcomp++)
                    if (jcomp < OCVdum->nChannels) 
                      pixel[jcomp] = *(((unsigned char *)OCVdum->imageData)+oglIdx*OCVdum->nChannels+jcomp);
                    else pixel[jcomp] = 255;
                  (img.Data)[oglIdx] = ipixel;
                }
              }
              cvReleaseImage(&OCVdum);
              break;

    default:  img.Data = NULL;
              break;
  }
  if (img.Data == NULL)
  { fprintf(stderr, "Error: Can't load image file \"%s\".\n", imgFil); 
    fprintf(stderr, "Press any key to exit"); _getch();  exit(1);
  } else { printf("%d x %d image loaded\n", img.Width, img.Height);
           if (!checkSize(img.Width) || !checkSize(img.Height))
           { printf("wrong image size!\n"); 
             /*printf("Press any key to continue\n"); _getch();*/ }
         }
  return;
}

